VERSION 5.00
Object = "*\A..\AlphaImgControl\LaVolpeAlphaImg.vbp"
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "COMDLG32.OCX"
Begin VB.Form frmPuzzle 
   Caption         =   "Puzzle Game"
   ClientHeight    =   5325
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   6525
   LinkTopic       =   "Form1"
   ScaleHeight     =   5325
   ScaleWidth      =   6525
   StartUpPosition =   3  'Windows Default
   Begin MSComDlg.CommonDialog CommonDialog1 
      Left            =   3435
      Top             =   1935
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.CommandButton cmdHelp 
      Caption         =   "?"
      Height          =   405
      Left            =   5760
      TabIndex        =   3
      Top             =   135
      Width           =   465
   End
   Begin VB.Timer tmrDone 
      Left            =   2685
      Top             =   1935
   End
   Begin VB.CommandButton cmdShowImage 
      Caption         =   "Show Full Image"
      Enabled         =   0   'False
      Height          =   405
      Left            =   4080
      TabIndex        =   2
      Top             =   135
      Width           =   1650
   End
   Begin VB.CommandButton cmdRedo 
      Caption         =   "Play Again"
      Enabled         =   0   'False
      Height          =   405
      Left            =   2415
      TabIndex        =   1
      Top             =   135
      Width           =   1650
   End
   Begin VB.CommandButton cmdStart 
      Caption         =   "Select Puzzle Image"
      Height          =   405
      Left            =   210
      TabIndex        =   0
      Top             =   135
      Width           =   2190
   End
   Begin VB.PictureBox picBoard 
      Height          =   4425
      Left            =   225
      ScaleHeight     =   291
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   397
      TabIndex        =   4
      TabStop         =   0   'False
      Top             =   555
      Width           =   6015
      Begin VB.PictureBox picInset 
         BorderStyle     =   0  'None
         Height          =   2640
         Left            =   450
         ScaleHeight     =   176
         ScaleMode       =   3  'Pixel
         ScaleWidth      =   221
         TabIndex        =   5
         TabStop         =   0   'False
         Top             =   480
         Width           =   3315
         Begin LaVolpeAlphaImg.AlphaImgCtl imgTile 
            Height          =   885
            Index           =   0
            Left            =   510
            Top             =   705
            Visible         =   0   'False
            Width           =   1065
            _ExtentX        =   1879
            _ExtentY        =   1561
            Blend           =   0
            Frame           =   16
            Object.Index           =   65537
            Effects         =   "frmPuzzle.frx":0000
         End
      End
   End
   Begin VB.Menu mnuPopup 
      Caption         =   "mnuPopup"
      Visible         =   0   'False
      Begin VB.Menu mnuGrid 
         Caption         =   "Small Grid"
         Index           =   0
      End
      Begin VB.Menu mnuGrid 
         Caption         =   "Medium Grid"
         Index           =   1
      End
      Begin VB.Menu mnuGrid 
         Caption         =   "Large Grid"
         Index           =   2
      End
   End
End
Attribute VB_Name = "frmPuzzle"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Type DragInfoStruct
    X As Single
    Y As Single
    Adjacents As Long
    Start As Long
    Direction As Long
    MouseAction As Boolean
End Type

Dim puzzleGrid() As Byte
Dim puzzleDrag As DragInfoStruct
Dim gridRows As Long
Dim gridCols As Long

Private Sub cmdHelp_Click()
    MsgBox "Put the image tiles in the correct order. You will always have 1 empty tile space to maneuver tiles." & vbCrLf & _
        "To move tiles, drag the tile(s) or double click on the one(s) to move." & vbCrLf & vbCrLf & _
        " To change background color, right click on the image" & vbCrLf & vbCrLf & _
        " Note: Dragging this message box over the tiles will erase them. This does not happen when control is compiled", vbInformation + vbOKOnly
End Sub

Private Sub cmdRedo_Click()
    mnuPopup.Tag = "replay"
    PopupMenu mnuPopup
End Sub

Private Sub cmdShowImage_Click()
    Load frmImage
    frmImage.ScaleMode = vbPixels
    Dim X As Long, Y As Long, Cx As Long, Cy As Long
    imgTile(1).SetRedraw = False
    imgTile(1).SegmentImage 0, 0
    GetScaledImageSize imgTile(1).Picture.Width, imgTile(1).Picture.Height, frmImage.ScaleWidth, frmImage.ScaleHeight, Cx, Cy
    X = (frmImage.ScaleWidth - Cx) \ 2
    Y = (frmImage.ScaleHeight - Cy) \ 2
    PaintPictureGDIplus imgTile(1).Picture, frmImage.hDC, X, Y, Cx, Cy
    imgTile(1).SetRedraw = True
    imgTile(1).SegmentImage gridRows, gridCols
    frmImage.Show
End Sub

Private Sub cmdStart_Click()
    mnuPopup.Tag = ""
    PopupMenu mnuPopup
End Sub

Private Sub DoBoardSetup(fromImage As GDIpImage)

    Dim Rows As Long, Columns As Long
    Dim Cx As Long, Cy As Long, Index As Long
    Dim tileImg As GDIpImage, SS As SAVESTRUCT
    Dim X As Long, Y As Long
    
    picInset.Visible = False
    Rows = gridRows
    Columns = gridCols
    
    X = Rows * Columns
    ReDim puzzleGrid(0 To X - 1)
    For X = 1 To X
        puzzleGrid(X - 1) = X
    Next
    puzzleGrid(0) = 0
    
    For Index = 2 To fromImage.ImageCount
        If fromImage.Width(Index) > fromImage.Width Then
            fromImage.ImageIndex = Index
        ElseIf fromImage.Height(Index) > fromImage.Height Then
            fromImage.ImageIndex = Index
        End If
    Next
    
    GetScaledImageSize fromImage.Width, fromImage.Height, picBoard.ScaleWidth - 2 - Columns * 2, picBoard.ScaleHeight - 2 - Rows * 2, Cx, Cy
    Cx = (Cx \ Columns) * Columns
    Cy = (Cy \ Rows) * Rows
    picInset.Move (picBoard.ScaleWidth - Cx - Columns * 2) \ 2, (picBoard.ScaleHeight - Cy - Rows * 2) \ 2, Cx + Columns * 2, Cy + Rows * 2
    
    Set tileImg = New GDIpImage
    With SS
        .Width = Cx
        .Height = Cy
    End With
    Call SavePictureGDIplus(fromImage, tileImg, lvicSaveAsPNG, SS)
    tileImg.SegmentImage Columns, Rows
    
    Cx = Rows * Columns
    For Cy = imgTile.UBound To Cx + 1 Step -1
        Unload imgTile(Cy)
    Next
    For Cy = 1 To Rows
        For Index = 1 To Cx - 1
            Y = Int(Rnd * Cx)
            If Y = 0 Then Y = 1
            X = puzzleGrid(Index)
            puzzleGrid(Index) = puzzleGrid(Y)
            puzzleGrid(Y) = X
        Next
    Next
    
    Cx = tileImg.Width
    Cy = tileImg.Height
    
    With imgTile(0)
        Set .Picture = Nothing
        .Visible = False
        .Move .Left, .Top, Cy + 2, Cx + 2
        .BorderColor = vbBlack
    End With
    
    Index = 1
    For Rows = 0 To Rows - 1
        For Columns = 0 To Columns - 1
            If Index > imgTile.UBound Then
                Load imgTile(Index)
                imgTile(Index).ZOrder
            End If
            With imgTile(Index)
                .SetRedraw = False
                .Border = True
                .Move Columns * Cx + Columns, Rows * Cy + Rows, Cx + 2, Cy + 2
                tileImg.ImageIndex = puzzleGrid(Index - 1)
                .Tag = puzzleGrid(Index - 1)
                If Index = 1 Then
                    Set .Picture = tileImg
                    puzzleGrid(Index - 1) = 0
                    .Enabled = False
                    .TransparencyPct = 75
                    .Border = False
                    .SetOffsets 1, 1
                Else
                    Call SavePictureGDIplus(tileImg, fromImage, lvicSaveAsCurrentFormat)
                    Set .Picture = fromImage
                    puzzleGrid(Index - 1) = Index
                    .Enabled = True
                End If
                .AlignCenter = False
                .Visible = True
                .SetRedraw = True
            End With
            Index = Index + 1
        Next
    Next
    
    Set tileImg = Nothing
    Set fromImage = Nothing
    
    picInset.Visible = True
    For Index = 2 To imgTile.UBound
        imgTile(Index).Picture.KeepOriginalFormat = False
    Next
    imgTile(1).ImageIndex = 1
    imgTile(0).Enabled = False
End Sub

Private Sub Form_Load()
    picBoard.ScaleMode = vbPixels
    picInset.ScaleMode = vbPixels
End Sub

Private Sub Form_Unload(Cancel As Integer)
    Unload frmImage
End Sub

Private Sub imgTile_DblClick(Index As Integer)
    If CreateDragImage(Index, False) Then MoveTiles False
End Sub

Private Sub imgTile_MouseDown(Index As Integer, Button As Integer, Shift As Integer, X As Single, Y As Single)
    If Button = vbLeftButton Then
        If puzzleDrag.Direction = 0 Then
            imgTile(Index).ZOrder
            imgTile(Index).BorderColor = vbYellow
        End If
    ElseIf Button = vbRightButton Then
        Call ChangeBackgroundColor
    End If
End Sub

Private Sub imgTile_MouseMove(Index As Integer, Button As Integer, Shift As Integer, X As Single, Y As Single)
    If Button = vbLeftButton Then
        If puzzleDrag.Direction = 0 Then
            If CreateDragImage(Index, True) Then
                puzzleDrag.X = X
                puzzleDrag.Y = Y
            End If
        ElseIf (puzzleDrag.Direction And 1) Then        ' moving horizontally
            imgTile(0).Left = imgTile(0).Left + (X - puzzleDrag.X)
            puzzleDrag.X = X
        Else
            imgTile(0).Top = imgTile(0).Top + (Y - puzzleDrag.Y)
            puzzleDrag.Y = Y
        End If
    End If
End Sub

Private Sub imgTile_MouseUp(Index As Integer, Button As Integer, Shift As Integer, X As Single, Y As Single)
    If Button = vbLeftButton Then
        If puzzleDrag.Direction Then
            MoveTiles False
        Else
            imgTile(Index).BorderColor = vbBlack
        End If
    End If
End Sub

Private Sub MoveTiles(Reset As Boolean)

    Dim X As Long, lReplaced As Long, lBlank As Long

    If puzzleDrag.Direction = 0 Then Exit Sub

    With puzzleDrag
        If (.Direction And 1) Then ' moved horizontally
            If .Direction < 0 Then
                If .MouseAction Then
                    X = puzzleGrid(.Start + .Adjacents - 1)
                    If imgTile(0).Left + imgTile(0).Width > imgTile(X).Left + imgTile(X).Width \ 2 Then Reset = True
                End If
                If Reset = False And .Start - 1 = 0 Then imgTile(1).Visible = False
                For X = .Start To .Start + .Adjacents - 1
                    imgTile(puzzleGrid(X)).TransparencyPct = 0
                    If Reset = False Then
                        imgTile(puzzleGrid(X)).Left = imgTile(puzzleGrid(X)).Left - imgTile(puzzleGrid(X)).Width + 1
                        puzzleGrid(X - 1) = puzzleGrid(X)
                    End If
                Next
                If Not Reset Then puzzleGrid(X - 1) = 0
            Else
                If .MouseAction Then
                    X = puzzleGrid(.Start)
                    If imgTile(0).Left < imgTile(X).Left + imgTile(X).Width \ 2 Then Reset = True
                End If
                For X = .Start + .Adjacents - 1 To .Start Step -1
                    imgTile(puzzleGrid(X)).TransparencyPct = 0
                    If Reset = False Then
                        imgTile(puzzleGrid(X)).Left = imgTile(puzzleGrid(X)).Left + imgTile(puzzleGrid(X)).Width - 1
                        puzzleGrid(X + 1) = puzzleGrid(X)
                    End If
                Next
                If Reset = False Then
                    puzzleGrid(X + 1) = 0
                    If X = -1 Then imgTile(1).Visible = True
                End If
            End If
        ElseIf .Direction < 1 Then
            If .MouseAction Then
                X = puzzleGrid(.Start + (.Adjacents - 1) * gridCols)
                If imgTile(0).Top + imgTile(0).Height > imgTile(X).Top + imgTile(X).Height \ 2 Then Reset = True
            End If
            If Reset = False And .Start - gridCols = 0 Then imgTile(1).Visible = False
            For X = .Start To .Start + .Adjacents * gridCols - gridCols Step gridCols
                imgTile(puzzleGrid(X)).TransparencyPct = 0
                If Reset = False Then
                    imgTile(puzzleGrid(X)).Top = imgTile(puzzleGrid(X)).Top - imgTile(puzzleGrid(X)).Height + 1
                    puzzleGrid(X - gridCols) = puzzleGrid(X)
                End If
            Next
            If Not Reset Then puzzleGrid(X - gridCols) = 0
        Else
            If .MouseAction Then
                X = puzzleGrid(.Start)
                If imgTile(0).Top < imgTile(X).Top + imgTile(X).Height \ 2 Then Reset = True
            End If
            For X = .Start + .Adjacents * gridCols - gridCols To .Start Step -gridCols
                imgTile(puzzleGrid(X)).TransparencyPct = 0
                If Reset = False Then
                    imgTile(puzzleGrid(X)).Top = imgTile(puzzleGrid(X)).Top + imgTile(puzzleGrid(X)).Height - 1
                    puzzleGrid(X + gridCols) = puzzleGrid(X)
                End If
            Next
            If Reset = False Then
                puzzleGrid(X + gridCols) = 0
                If X = -gridCols Then imgTile(1).Visible = True
            End If
        End If
        .Direction = 0
    End With
    imgTile(0).Visible = False
    Set imgTile(0).Picture = Nothing

    For X = gridCols * gridCols - 1 To 1 Step -1
        If Val(imgTile(puzzleGrid(X)).Tag) < Val(imgTile(puzzleGrid(X - 1)).Tag) Then Exit For
    Next
    If X = 0 Then
        For X = 2 To imgTile.UBound
            imgTile(X).Visible = False
        Next
        With imgTile(1)
            .SegmentImage 0, 0
            .Move .Left, .Top, .Picture.Width + 2, .Picture.Height + 2
            .AlignCenter = True
            .TransparencyPct = 0
        End With
        tmrDone.Interval = 100
        tmrDone.Enabled = True
    End If

End Sub

Private Function CreateDragImage(Index As Integer, bCreate As Boolean) As Boolean

    Dim X As Long, Row As Long, Col As Long, PMS As PICTUREMERGESTRUCT
    
    Row = imgTile(Index).Top \ (imgTile(Index).Height - 2)
    Col = imgTile(Index).Left \ (imgTile(Index).Width - 2)
    
    For X = 0 To gridCols - 1
        If X <> Col Then
            If puzzleGrid(Row * gridCols + X) = 0 Then
                puzzleDrag.Direction = 1
                If X < Col Then puzzleDrag.Direction = -puzzleDrag.Direction
                Exit For
            End If
        End If
    Next
    If puzzleDrag.Direction = 0& Then
        For X = 0 To gridRows - 1
            If X <> Row Then
                If puzzleGrid(X * gridCols + Col) = 0 Then
                    puzzleDrag.Direction = 2
                    If X < Row Then puzzleDrag.Direction = -puzzleDrag.Direction
                    Exit For
                End If
            End If
        Next
    End If
    
    If puzzleDrag.Direction Then
        imgTile(Index).BorderColor = vbBlack
        Dim imgComposite As New GDIpImage
        With PMS
            If (puzzleDrag.Direction And 1) Then     ' horizontal
                puzzleDrag.Adjacents = Abs(X - Col)
                If puzzleDrag.Direction < 0 Then     ' moves to left only
                    puzzleDrag.Start = X + 1 + (Row * gridCols)
                Else
                    puzzleDrag.Start = Col + Row * gridCols
                End If
                If bCreate Then
                    ReDim .MIS(0 To puzzleDrag.Adjacents - 1)
                    .CanvasWidth = puzzleDrag.Adjacents * (imgTile(Index).Width - 2)
                    .CanvasHeight = imgTile(Index).Height - 2
                    imgTile(0).Move imgTile(puzzleGrid(puzzleDrag.Start)).Left, imgTile(puzzleGrid(puzzleDrag.Start)).Top, .CanvasWidth + 2, .CanvasHeight + 2
                    For X = puzzleDrag.Start To puzzleDrag.Start + puzzleDrag.Adjacents - 1
                        Set .MIS(.Pictures).Picture = imgTile(puzzleGrid(X)).Picture
                        imgTile(puzzleGrid(X)).TransparencyPct = 75
                        .MIS(.Pictures).Left = .Pictures * (imgTile(Index).Width - 2)
                        .Pictures = .Pictures + 1
                    Next
                End If
            Else
                puzzleDrag.Adjacents = Abs(X - Row)
                If puzzleDrag.Direction < 0 Then     ' moves to top only
                    puzzleDrag.Start = (X + 1) * gridCols + Col
                Else
                    puzzleDrag.Start = Col + Row * gridCols
                End If
                If bCreate Then
                    ReDim .MIS(0 To puzzleDrag.Adjacents - 1)
                    .CanvasHeight = puzzleDrag.Adjacents * (imgTile(Index).Height - 2)
                    .CanvasWidth = imgTile(Index).Height - 2
                    imgTile(0).Move imgTile(puzzleGrid(puzzleDrag.Start)).Left, imgTile(puzzleGrid(puzzleDrag.Start)).Top, .CanvasWidth + 2, .CanvasHeight + 2
                    For X = puzzleDrag.Start To puzzleDrag.Start + (puzzleDrag.Adjacents - 1) * gridCols Step gridCols
                        Set .MIS(.Pictures).Picture = imgTile(puzzleGrid(X)).Picture
                        imgTile(puzzleGrid(X)).TransparencyPct = 75
                        .MIS(.Pictures).Top = .Pictures * (imgTile(Index).Height - 2)
                        .Pictures = .Pictures + 1
                    Next
                End If
            End If
        End With
        puzzleDrag.MouseAction = bCreate
        If bCreate Then
            Set imgComposite = MergePictureGDIplus(PMS)
            With imgTile(0)
                .BorderColor = vbRed
                Set .Picture = imgComposite
                .ZOrder
                .Visible = True
            End With
        End If
        CreateDragImage = True
    End If
End Function

Private Sub mnuGrid_Click(Index As Integer)

    If mnuPopup.Tag = "" Then
        Dim cOpenDlg As UnicodeFileDialog, cImage As GDIpImage
        Set cOpenDlg = New UnicodeFileDialog
        With cOpenDlg
            .Flags = OFN_EXPLORER Or OFN_FILEMUSTEXIST
            .Filter = "All Files|*.*|" & _
                "Supported Formats|*.bmp;*.cur;*.ani;*.gif;*.ico;*.jpg;*.jpeg;*.emf;*.wmf;*.mp3;*.png;*.apng;*.tga;*.tif;*.tiff|" & _
                "Bitmap|*.bmp|Cursor|*.cur;*.ani|GIF|*.gif|Icon|*.ico|JPEG|*.jpg;*.jpeg|" & _
                "Metafile|*.emf;*.wmf|MP3|*.mp3|PNG|*.png;*.apng|Targa (TGA)|*.tga|TIFF|*.tif;*.tiff"
            .FilterIndex = 2
            .DialogTitle = "Select Puzzle Image"
        End With
        If cOpenDlg.ShowOpen(Me.hWnd) Then
            On Error Resume Next
            Set cImage = LoadPictureGDIplus(cOpenDlg.FileName, , False)
            If Err Then
                MsgBox "Could not use that file. Try another.", vbInformation + vbOKOnly
                Exit Sub
            End If
            cmdRedo.Enabled = True
            cmdShowImage.Enabled = True
            Unload frmImage
        Else
            Exit Sub
        End If
    Else
        Set cImage = imgTile(1).Picture
        cImage.SegmentImage 0, 0
    End If
    Select Case Index
    Case 0: gridCols = 3
    Case 1: gridCols = 4
    Case 2: gridCols = 5
    End Select
    gridRows = gridCols
    
    DoBoardSetup cImage
    
End Sub

Private Sub picBoard_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    If Button = vbRightButton Then
        Call ChangeBackgroundColor
    End If
End Sub

Private Sub picInset_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    If Button = vbRightButton Then
        Call ChangeBackgroundColor
    End If
End Sub

Private Sub tmrDone_Timer()
    imgTile(1).Rotation = imgTile(1).Rotation + 15
    If imgTile(1).Rotation = 360 Then
        tmrDone.Enabled = False
        imgTile(1).Rotation = 0
    End If
End Sub

Private Sub ChangeBackgroundColor()
    With CommonDialog1
        .Flags = cdlCCRGBInit
        .Color = picInset.BackColor
        .CancelError = True
    End With
    On Error Resume Next
    CommonDialog1.ShowColor
    If Err Then
        Err.Clear
    Else
        picBoard.BackColor = CommonDialog1.Color
        picInset.BackColor = picBoard.BackColor
    End If
End Sub
