VERSION 5.00
Object = "*\A..\AlphaImgControl\LaVolpeAlphaImg.vbp"
Begin VB.Form frmAnimation 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Animation Sample"
   ClientHeight    =   5745
   ClientLeft      =   105
   ClientTop       =   405
   ClientWidth     =   7260
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   383
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   484
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdMirror 
      Caption         =   "Toggle Fish Direction"
      Height          =   570
      Left            =   4950
      TabIndex        =   2
      Top             =   3840
      Width           =   1995
   End
   Begin VB.CommandButton cmdDoFish 
      Caption         =   "Animate Fish && Ball"
      Height          =   570
      Left            =   4950
      TabIndex        =   1
      Top             =   3255
      Width           =   1995
   End
   Begin VB.CommandButton cmdSonic 
      Caption         =   "Start/Stop Animation"
      Height          =   495
      Left            =   165
      TabIndex        =   0
      Top             =   2310
      Width           =   1935
   End
   Begin VB.Label Label3 
      Caption         =   "   << This image is an animated PNG (APNG). Rare but neat"
      Height          =   390
      Left            =   2205
      TabIndex        =   5
      Top             =   4785
      Width           =   4740
   End
   Begin LaVolpeAlphaImg.AlphaImgCtl AlphaImgCtl1 
      Height          =   1890
      Left            =   150
      Top             =   360
      Width           =   6825
      _ExtentX        =   12039
      _ExtentY        =   3334
      Image           =   "frmAnimation.frx":0000
      Frame           =   20
      BackColor       =   8421376
      Attr            =   516
      FixedCx         =   100
      FixedCy         =   100
      Effects         =   "frmAnimation.frx":13C9
   End
   Begin LaVolpeAlphaImg.AlphaImgCtl AlphaImgCtl2 
      Height          =   1020
      Left            =   195
      Top             =   2850
      Width           =   4515
      _ExtentX        =   7964
      _ExtentY        =   1799
      Image           =   "frmAnimation.frx":13E1
      Attr            =   514
      Effects         =   "frmAnimation.frx":3A0B3
   End
   Begin VB.Label Label1 
      Caption         =   $"frmAnimation.frx":3A0CB
      Height          =   720
      Left            =   2220
      TabIndex        =   3
      Top             =   2280
      Width           =   4785
   End
   Begin LaVolpeAlphaImg.AlphaImgCtl AlphaImgCtl3 
      Height          =   2235
      Left            =   180
      Top             =   3480
      Width           =   1890
      _ExtentX        =   3334
      _ExtentY        =   3942
      Image           =   "frmAnimation.frx":3A194
      Attr            =   514
      FrameDur        =   3604480
      Effects         =   "frmAnimation.frx":4A4EB
   End
   Begin VB.Label Label2 
      Caption         =   "The goldfish is a PNG with 20 frames in a 2x10 grid. By segmenting the image, we can treat it as an animated GIF of sorts."
      Height          =   705
      Left            =   195
      TabIndex        =   4
      Top             =   3810
      Width           =   4740
   End
End
Attribute VB_Name = "frmAnimation"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Const lBufferX As Long = 24
Private Const lBufferY As Long = 46
Private lDirection As Long

Private Sub AlphaImgCtl1_AnimationFrameChanged(Index As Long)
    Me.Caption = "Frame #" & Index
    Select Case lDirection
    Case 0
        AlphaImgCtl1.SetOffsets AlphaImgCtl1.XOffset + lBufferX \ 2, AlphaImgCtl1.YOffset
        If AlphaImgCtl1.XOffset + AlphaImgCtl1.Picture.Width > AlphaImgCtl1.Width - lBufferX \ 2 Then lDirection = 1
    Case 1
        AlphaImgCtl1.Rotation = -45
        AlphaImgCtl1.SetOffsets AlphaImgCtl1.XOffset + lBufferX, AlphaImgCtl1.YOffset - lBufferY \ 2
        lDirection = 2
    Case 2
        AlphaImgCtl1.Rotation = -90
        AlphaImgCtl1.SetOffsets AlphaImgCtl1.XOffset, AlphaImgCtl1.YOffset - lBufferY \ 2
        lDirection = 3
    Case 3
        AlphaImgCtl1.Rotation = -145
        AlphaImgCtl1.SetOffsets AlphaImgCtl1.XOffset, AlphaImgCtl1.YOffset - lBufferY \ 2
        lDirection = 4
    Case 4
        AlphaImgCtl1.Rotation = -180
        AlphaImgCtl1.SetOffsets AlphaImgCtl1.XOffset - lBufferX \ 2, AlphaImgCtl1.YOffset
        lDirection = 5
    Case 5
        If AlphaImgCtl1.XOffset > 0 Then
            AlphaImgCtl1.SetOffsets AlphaImgCtl1.XOffset - lBufferX \ 2, AlphaImgCtl1.YOffset
        Else
            AlphaImgCtl1.Rotation = -225
            AlphaImgCtl1.SetOffsets AlphaImgCtl1.XOffset - lBufferX, AlphaImgCtl1.YOffset + lBufferY \ 2
            lDirection = 6
        End If
    Case 6
        AlphaImgCtl1.Rotation = 90
        AlphaImgCtl1.SetOffsets AlphaImgCtl1.XOffset, AlphaImgCtl1.YOffset + lBufferY \ 2
        lDirection = 7
    Case 7
        AlphaImgCtl1.Rotation = 45
        AlphaImgCtl1.SetOffsets AlphaImgCtl1.XOffset + lBufferX \ 2, AlphaImgCtl1.YOffset + lBufferY \ 2
        lDirection = 8
    Case 8
        AlphaImgCtl1.Rotation = 0
        AlphaImgCtl1.SetOffsets AlphaImgCtl1.XOffset + lBufferX \ 2, AlphaImgCtl1.YOffset
        lDirection = 0
        AlphaImgCtl1.BackColor = AlphaImgCtl1.BackColor Xor &H204020
    End Select
End Sub

Private Sub cmdSonic_Click()
    Select Case AlphaImgCtl1.Animate2.AnimationState
    Case lvicAniCmdPause: AlphaImgCtl1.Animate2.ResumeAnimation
    Case lvicAniCmdStart: AlphaImgCtl1.Animate2.PauseAnimation
    Case lvicAniCmdStop: AlphaImgCtl1.Animate2.StartAnimation
        AlphaImgCtl1.BackStyleOpaque = True
        AlphaImgCtl1.AlignCenter = False
        AlphaImgCtl1.SetOffsets -lBufferX, lBufferY
    End Select
End Sub

Private Sub cmdMirror_Click()
    AlphaImgCtl2.Mirror = AlphaImgCtl2.Mirror Xor lvicMirrorHorizontal
End Sub

Private Sub cmdDoFish_Click()
    With AlphaImgCtl2
        .SegmentImage 2, 10, , 35       ' see bonus code below
        .Aspect = lvicActualSize
        .AutoSize = lvicSingleAngle
        .Left = .Left + .Width
    End With
    AlphaImgCtl2.Animate2.StartAnimation ' goldfish
    AlphaImgCtl3.Animate2.StartAnimation ' atom
    cmdDoFish.Enabled = False
End Sub

' bonus code.
' The goldfish was originally a single row of 20 columns.
' But I didn't like it in that format, so I used the available functions
' to convert it to 2 rows of 10 each.  And this is what I used...
' AlphaImgCtl2 originally was loaded with the 20 column PNG

'  #  Dim tImage As GDIpImage
'  #  Dim PMS As PICTUREMERGESTRUCT
'  #      With PMS
'  #          .CanvasWidth = AlphaImgCtl2.Picture.Width \ 2
'  #          .CanvasHeight = AlphaImgCtl2.Picture.Height * 2
'  #          .Pictures = 2
'  #          ReDim .MergeInfo(0 To 1)
'  #          With .MergeInfo(0)
'  #               Set .Picture = AlphaImgCtl2.Picture
'  #               ' leave .Left & .Top at 0, basically rendering 1st 10 frames on new 1st row
'  #          End With
'  #          With .MergeInfo(1)
'  #              Set .Picture = AlphaImgCtl2.Picture
'  #              ' offset left so 2nd 10 frames start on left edge of row
'  #              ' offset top so 2nd row starts below first row
'  #              .Left = -PMS.CanvasWidth
'  #              .Top = PMS.CanvasHeight \ 2
'  #          End With
'  #      End With
'  #      Set tImage = MergePictureGDIplus(PMS)
'  #      SavePictureGDIplus tImage, App.Path & "\Goldfish_Grid2x5.png", lvicSaveAsPNG

