VERSION 5.00
Object = "*\A..\AlphaImgControl\LaVolpeAlphaImg.vbp"
Begin VB.Form frmDragDrop 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Drag and Drop"
   ClientHeight    =   3090
   ClientLeft      =   -15
   ClientTop       =   375
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   3090
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
   Begin VB.Shape Shape1 
      Height          =   1725
      Left            =   2340
      Top             =   255
      Width           =   1920
   End
   Begin VB.Label Label1 
      Caption         =   $"frmDragDrop.frx":0000
      Height          =   720
      Left            =   210
      TabIndex        =   0
      Top             =   2145
      Width           =   4200
   End
   Begin VB.Image Image1 
      Height          =   1695
      Left            =   2355
      OLEDragMode     =   1  'Automatic
      OLEDropMode     =   1  'Manual
      Stretch         =   -1  'True
      Top             =   270
      Width           =   1890
   End
   Begin LaVolpeAlphaImg.AlphaImgCtl AlphaImgCtl1 
      Height          =   1725
      Left            =   165
      Top             =   255
      Width           =   1920
      _ExtentX        =   3387
      _ExtentY        =   3043
      Blend           =   0
      Frame           =   20
      Attr            =   555
      Object.Index           =   65537
      Effects         =   "frmDragDrop.frx":0096
   End
End
Attribute VB_Name = "frmDragDrop"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub AlphaImgCtl1_Changed()
    
    If AlphaImgCtl1.Picture.ImageCount > 1 Then
        Select Case AlphaImgCtl1.Picture.ImageFormat
        Case lvicPicTypeAnimatedCursor, lvicPicTypeGIF, lvicPicTypePNG
            AlphaImgCtl1.Animate lvicAniCmdStart
        End Select
    End If

End Sub

Private Sub Image1_OLEDragDrop(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single)
    
    Dim cx As Long, cy As Long
    
    On Error Resume Next
    Image1.Visible = False
    If Data.GetFormat(vbCFEMetafile) Then
        Set Image1.Picture = Data.GetData(vbCFEMetafile)
    ElseIf Data.GetFormat(vbCFMetafile) Then
        Set Image1.Picture = Data.GetData(vbCFMetafile)
    ElseIf Data.GetFormat(vbCFBitmap) Then
        Set Image1.Picture = Data.GetData(vbCFBitmap)
    ElseIf Data.GetFormat(vbCFFiles) Then
        Image1.Picture = LoadPicture(Data.Files(1))
    End If
    If Image1.Picture Then
        GetScaledImageSize ScaleX(Image1.Picture.Width, vbHimetric, vbTwips), ScaleY(Image1.Picture.Height, vbHimetric, vbTwips), _
            Shape1.Width - Screen.TwipsPerPixelX * 2, Shape1.Height - Screen.TwipsPerPixelY * 2, _
            cx, cy, , False, False
        Image1.Move (Shape1.Width - cx) \ 2 + Shape1.Left, (Shape1.Height - cy) \ 2 + Shape1.Top, cx, cy
        Effect = vbDropEffectCopy
    Else
        Image1.Move Shape1.Left, Shape1.Top, Shape1.Width, Shape1.Height
    End If
    Image1.Visible = True
    
End Sub

Private Sub Image1_OLEDragOver(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single, State As Integer)
    Effect = vbDropEffectCopy
End Sub

Private Sub Image1_OLEGiveFeedback(Effect As Long, DefaultCursors As Boolean)
    Effect = vbDropEffectCopy
End Sub
